#=
Created on 20 Jun 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 005 of Project Euler
https://projecteuler.net/problem=5
=#

#=
The LCM of two natural numbers x and y is given by:
def lcm(x, y):
    return x * y // math.gcd(x, y)

It is possible to compute the LCM of more than two numbers by iteratively
computing the LCM of two numbers, i.e. LCM(a, b, c) = LCM(a, LCM(b, c))
=#

using BenchmarkTools

function Problem005()
    #=
    2520 is the smallest number that can be divided by each of the numbers
    from 1 to 10 without any remainder.

    What is the smallest positive number that is evenly divisible by all of
    the numbers from 1 to 20?
    =#

    ans = 1
    for i = 1:21
        ans *= i ÷ gcd(i, ans)
    end

    return ans
end


println("Took:")
@btime Problem005()
println("")
println("Result for Problem $(lpad(5, 3, "0")): ", Problem005())
