#=
Created on 20 Jun 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for Problem 006 of Project Euler
https://projecteuler.net/problem=6
=#

using BenchmarkTools

function Problem006()
    #=
    The sum of the squares of the first ten natural numbers is,
    1^2 + 2^2 + ... + 10^2 = 385

    The square of the sum of the first ten natural numbers is,
    (1 + 2 + ... + 10)^2 = 55^2 = 3025

    Hence the difference between the sum of the squares of the first ten
    natural numbers and the square of the sum is 3025 − 385 = 2640.

    Find the difference between the sum of the squares of the first one
    hundred natural numbers and the square of the sum.
    =#

    n = 100
    square_of_sum = sum(i for i = 1:n)^2
    sum_squares = sum(i^2 for i = 1:n)
    ans = square_of_sum - sum_squares

    return ans
end


println("Took:")
@btime Problem006()
println("")
println("Result for Problem $(lpad(6, 3, "0")): ", Problem006())
