#!/usr/bin/env python3
"""
Creation of templates for the problems of Project Euler
"""

import datetime
import inspect
from argparse import ArgumentParser


def create_problem():
    with open(Problem, "w+") as f:
        template = inspect.cleandoc(
            f"""
                                    #=
                                    Created on {today}

                                    @author: David Doblas Jiménez
                                    @email: daviddoji@pm.me

                                    Solution for Problem {args['problem']:0>3} of Project Euler
                                    https://projecteuler.net/problem={args['problem']}
                                    =#

                                    using BenchmarkTools

                                    function Problem{args['problem']:0>3}()
                                        #=
                                        Statement
                                        =#

                                        # Your code goes here
                                        return
                                    end


                                    println("Took:")
                                    @btime Problem{args['problem']:0>3}()
                                    println("")
                                    println("Result for Problem $(lpad({args['problem']}, 3, "0")): ", Problem{args['problem']:0>3}())
                                    """  # noqa: E501
        )

        f.write(template)


if __name__ == "__main__":
    today = datetime.datetime.now().strftime("%d %b %Y")
    parser = ArgumentParser(description=__doc__)
    # Add your arguments here
    parser.add_argument("-p", "--problem", help="number of the problem to solve")
    args = vars(parser.parse_args())
    Problem = f"Problem{(args['problem']):0>3}.jl"
    create_problem()
