#!/usr/bin/env python
"""
Created on 26 Sep 2021

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 052 of Project Euler
https://projecteuler.net/problem=52
"""

from utils import timeit


@timeit("Problem 052")
def compute():
    """
    It can be seen that the number, 125874, and its double, 251748,
    contain exactly the same digits, but in a different order.

    Find the smallest positive integer, x, such that 2x, 3x, 4x, 5x,
    and 6x, contain the same digits.
    """

    for number in range(123_456, 1_000_000):
        if (
            sorted(str(number))
            == sorted(str(2 * number))
            == sorted(str(3 * number))
            == sorted(str(4 * number))
            == sorted(str(5 * number))
            == sorted(str(6 * number))
        ):
            return number


if __name__ == "__main__":
    print(f"Result for Problem 052: {compute()}")
