#!/usr/bin/env python
"""
Created on 18 Mar 2017

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 004 of Project Euler
https://projecteuler.net/problem=4
"""

from utils import timeit


@timeit("Problem 004")
def compute():
    """
    A palindromic number reads the same both ways. The largest palindrome made
    from the product of two 2-digit numbers is 9009 = 91 x 99.

    Find the largest palindrome made from the product of two 3-digit numbers.
    """

    ans = 0
    for i in range(100, 1_000):
        for j in range(100, 1_000):
            palindrome = i * j
            s = str(palindrome)
            if s == s[::-1] and palindrome > ans:
                ans = palindrome

    return ans


if __name__ == "__main__":
    print(f"Result for problem 004: {compute()}")
