#!/usr/bin/env python
"""
Created on 13 Jan 2018

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 016 of Project Euler
https://projecteuler.net/problem=16
"""

from utils import timeit


@timeit("Problem 016")
def compute():
    """
    2^15 = 32768 and the sum of its digits is 3 + 2 + 7 + 6 + 8 = 26.

    What is the sum of the digits of the number 2^1000?
    """

    n = 1000
    ans = sum(int(digit) for digit in str(2**n))

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 016: {compute()}")
