#!/usr/bin/env python
"""
Created on 31 Dec 2018

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 022 of Project Euler
https://projecteuler.net/problem=22
"""

from pathlib import Path

from utils import timeit


@timeit("Problem 022")
def compute():
    """
    Using names.txt, a 46K text file containing over five-thousand first names,
    begin by sorting it into alphabetical order. Then working out the
    alphabetical value for each name, multiply this value by its alphabetical
    position in the list to obtain a name score.

    For example, when the list is sorted into alphabetical order, COLIN, which
    is worth 3 + 15 + 12 + 9 + 14 = 53, is the 938th name in the list. So,
    COLIN would obtain a score of 938 x 53 = 49714.

    What is the total of all the name scores in the file?
    """

    file = Path("files/Problem22.txt")
    with open(file, "r") as f:
        names = sorted(f.read().replace('"', "").split(","))

    ans = 0
    for idx, name in enumerate(names, 1):
        ans += sum(ord(char) - 64 for char in name) * idx

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 022: {compute()}")
