#!/usr/bin/env python
"""
Created on 11 Sep 2019

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 025 of Project Euler
https://projecteuler.net/problem=25
"""

from utils import timeit


@timeit("Problem 025")
def compute():
    """
    The Fibonacci sequence is defined by the recurrence relation:

        Fn = Fn-1 + Fn-2, where F1 = 1 and F2 = 1.

    Hence the first 12 terms will be:

        F1 = 1
        F2 = 1
        F3 = 2
        F4 = 3
        F5 = 5
        F6 = 8
        F7 = 13
        F8 = 21
        F9 = 34
        F10 = 55
        F11 = 89
        F12 = 144

    The 12th term, F12, is the first term to contain three digits.

    What is the index of the first term in the Fibonacci sequence to
    contain 1000 digits?
    """

    a, b = 1, 1
    ans = 2
    while len(str(b)) < 1000:
        a, b = b, b + a
        ans += 1

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 025: {compute()}")
