#!/usr/bin/env python
"""
Created on 3 Jan 2020

@author: David Doblas Jiménez
@email: daviddoji@pm.me

Solution for problem 030 of Project Euler
https://projecteuler.net/problem=30
"""

from utils import timeit


def power_digit_sum(pow, n):
    return sum(int(c) ** pow for c in str(n))


@timeit("Problem 030")
def compute():
    """
    Surprisingly there are only three numbers that can be written as the sum
    of fourth powers of their digits:

        1634 = 1^4 + 6^4 + 3^4 + 4^4
        8208 = 8^4 + 2^4 + 0^4 + 8^4
        9474 = 9^4 + 4^4 + 7^4 + 4^4

    As 1 = 14 is not a sum it is not included.

    The sum of these numbers is 1634 + 8208 + 9474 = 19316.

    Find the sum of all the numbers that can be written as the sum of fifth
    powers of their digits.
    """

    ans = sum(i for i in range(2, 1_000_000) if i == power_digit_sum(5, i))

    return ans


if __name__ == "__main__":
    print(f"Result for Problem 030: {compute()}")
